# frozen_string_literal: true

require_relative 'jekyll-activity-pub-absolute-assets'

# Convert all embedded images, videos and audios into attachments. Note
# Mastodon only supports four attachments per post.
#
# The hook run after absolute assets.
Jekyll::Hooks.register :activity, :post_init, priority: 34 do |activity|
  activity.data['content'].css('img[src],video[src],audio[src]').each do |element|
    src = Addressable::URI.parse(element['src'])

    activity.data['attachment'] << Jekyll::ActivityPub::Document.new(activity.site, src.path, element['alt'].to_s)
  end
end
